.filter-item {
  vertical-align: top;

  &.reset-filters {
    padding: 7px;
  }

  &.update-issues-btn {
    float: right;
    margin-right: 0;

    @media (max-width: $screen-xs-max) {
      float: none;
    }
  }
}

.filters-section {
  @media (max-width: $screen-xs-max) {
    display: inline-block;
  }
}

@media (min-width: $screen-sm-min) {
  .issues_bulk_update {
    .dropdown-menu-toggle:not(.wide) {
      width: 132px;
    }
  }

  .filter-item:not(:last-child) {
    margin-right: 6px;
  }

  .sort-filter {
    display: inline-block;
    float: right;
  }

  .dropdown-menu-sort {
    left: auto;
    right: 0;
  }
}

@media (max-width: $screen-xs-max) {
  .filter-item {
    display: block;
    margin: 0 0 10px;
  }

  .dropdown-menu-toggle,
  .update-issues-btn .btn {
    width: 100%;
  }
}

.filtered-search-wrapper {
  display: -webkit-flex;
  display: flex;

  @media (max-width: $screen-xs-min) {
    -webkit-flex-direction: column;
    flex-direction: column;
  }

  .tokens-container {
    display: -webkit-flex;
    display: flex;
    flex: 1;
    -webkit-flex: 1;
    padding-left: 30px;
    position: relative;
    margin-bottom: 0;
  }

  .input-token {
    max-width: 200px;
  }

  .input-token:only-child,
  .input-token:last-child {
    flex: 1;
    -webkit-flex: 1;
    max-width: inherit;
  }
}

.filtered-search-token,
.filtered-search-term {
  display: -webkit-flex;
  display: flex;
  margin-top: 5px;
  margin-bottom: 5px;

  .selectable {
    display: -webkit-flex;
    display: flex;
  }

  .name,
  .value {
    display: inline-block;
    padding: 2px 7px;
  }

  .value {
    padding-right: 0;
  }

  .remove-token {
    display: inline-block;
    padding-left: 4px;
    padding-right: 8px;

    .fa-close {
      color: $gl-text-color-secondary;
    }

    &:hover .fa-close {
      color: $gl-text-color;
    }

    &.inverted {
      .fa-close {
        color: $gl-text-color-secondary-inverted;
      }

      &:hover .fa-close {
        color: $gl-text-color-inverted;
      }
    }
  }

  .name {
    background-color: $filter-name-resting-color;
    color: $filter-name-text-color;
    border-radius: 2px 0 0 2px;
    margin-right: 1px;
    text-transform: capitalize;
  }

  .value-container {
    background-color: $white-normal;
    color: $filter-value-text-color;
    border-radius: 0 2px 2px 0;
    margin-right: 5px;
  }

  .selected {
    .name {
      background-color: $filter-name-selected-color;
    }

    .value-container {
      background-color: $filter-value-selected-color;
    }
  }
}

.filtered-search-term {
  .name {
    background-color: inherit;
    color: $black;
    text-transform: none;
  }

  .selectable {
    cursor: text;
  }
}

.scroll-container {
  display: -webkit-flex;
  display: flex;
  overflow-x: auto;
  white-space: nowrap;
  width: 100%;
}

.filtered-search-box {
  position: relative;
  flex: 1;
  display: -webkit-flex;
  display: flex;
  width: 100%;
  min-width: 0;
  border: 1px solid $border-color;
  background-color: $white-light;

  @media (max-width: $screen-xs-min) {
    -webkit-flex: 1 1 auto;
    flex: 1 1 auto;
    margin-bottom: 10px;
  }

  &:hover {
    @extend .form-control:hover;
  }

  &.focus,
  &.focus:hover {
    border-color: $dropdown-input-focus-border;
    box-shadow: 0 0 4px $search-input-focus-shadow-color;
  }

  &.focus .fa-filter {
    color: $common-gray-dark;
  }

  .form-control {
    position: relative;
    min-width: 200px;
    padding: 5px 25px 6px 0;
    border-color: transparent;

    &:focus,
    &:hover {
      outline: none;
      border-color: transparent;
      box-shadow: none;
    }
  }

  .fa-filter {
    position: absolute;
    top: 10px;
    left: 10px;
    color: $gray-darkest;
  }

  .fa-times {
    right: 10px;
    color: $gray-darkest;
  }

  .clear-search {
    width: 35px;
    background-color: $white-light;
    border: none;
    position: absolute;
    right: 0;
    height: 100%;
    outline: none;
    z-index: 1;

    &:hover .fa-times {
      color: $common-gray-dark;
    }
  }
}

.filtered-search-box-input-container {
  flex: 1;
  position: relative;
  // Fix PhantomJS not supporting `flex: 1;` properly.
  // This is important because it can change the expected `e.target` when clicking things in tests.
  // See https://gitlab.com/gitlab-org/gitlab-ce/blob/b54acba8b732688c59fe2f38510c469dc86ee499/spec/features/issues/filtered_search/visual_tokens_spec.rb#L61
  // - With `width: 100%`: `e.target` = `.tokens-container`, https://i.imgur.com/jGq7wbx.png
  // - Without `width: 100%`: `e.target` = `.filtered-search`, https://i.imgur.com/cNI2CyT.png
  width: 100%;
  min-width: 0;
}

.filtered-search-input-dropdown-menu {
  max-width: 280px;

  @media (max-width: $screen-xs-min) {
    width: auto;
    left: 0;
    right: 0;
    max-width: none;
    min-width: 100%;
  }
}

.filtered-search-history-dropdown-wrapper {
  position: static;
  display: flex;
  flex-direction: column;
}

.filtered-search-history-dropdown-toggle-button {
  flex: 1;
  width: auto;
  border-radius: 0;
  border: 0;
  border-right: 1px solid $border-color;
  color: $gl-text-color-secondary;
  transition: color 0.1s linear;

  &:hover,
  &:focus {
    color: $gl-text-color;
    border-color: $dropdown-input-focus-border;
    outline: none;

    svg {
      fill: $gl-text-color;
    }
  }

  svg {
    height: 14px;
    width: 14px;
    fill: $gl-text-color-secondary;
    vertical-align: middle;
  }

  .dropdown-toggle-text {
    display: inline-block;
    color: inherit;

    .fa {
      vertical-align: middle;
      color: inherit;
    }
  }
}

.filtered-search-history-dropdown {
  width: 40%;

  @media (max-width: $screen-xs-min) {
    left: 0;
    right: 0;
    max-width: none;
  }
}

.filtered-search-history-dropdown-content {
  max-height: none;
}

.filtered-search-history-dropdown-item,
.filtered-search-history-clear-button {
  @include dropdown-link;

  overflow: hidden;
  width: 100%;
  margin: 0.5em 0;

  background-color: transparent;
  border: 0;
  text-align: left;
  white-space: nowrap;
  text-overflow: ellipsis;
}

.filtered-search-history-dropdown-token {
  display: inline;

  &:not(:last-child) {
    margin-right: 0.3em;
  }

  & > .value {
    font-weight: 600;
  }
}

.filter-dropdown-container {
  display: -webkit-flex;
  display: flex;

  .dropdown-toggle {
    line-height: 22px;
  }
}

.dropdown-menu .filter-dropdown-item {
  padding: 0;
}

.filter-dropdown {
  max-height: 215px;
  overflow: auto;
}

@media (min-width: $screen-sm-min) and (max-width: $screen-sm-max) {
  .issue-bulk-update-dropdown-toggle {
    width: 100px;
  }
}

@media (max-width: $screen-xs-max) {
  .issues-details-filters {
    padding: 0 0 10px;
    background-color: $white-light;
    border-top: 0;
  }
}

@media (max-width: $screen-xs) {
  .filter-dropdown-container {
    .dropdown-toggle,
    .dropdown {
      width: 100%;
    }

    .dropdown {
      margin-left: 0;
    }

    .fa-chevron-down {
      position: absolute;
      right: 10px;
      top: 10px;
    }
  }
}

%filter-dropdown-item-btn-hover {
  background-color: $dropdown-hover-color;
  color: $white-light;
  text-decoration: none;

  .avatar {
    border-color: $white-light;
  }
}

.filter-dropdown-item {
  .btn {
    border: none;
    width: 100%;
    text-align: left;
    padding: 8px 16px;
    text-overflow: ellipsis;
    overflow: hidden;
    border-radius: 0;

    .fa {
      width: 15px;
    }

    .dropdown-label-box {
      border-color: $white-light;
      border-style: solid;
      border-width: 1px;
      width: 17px;
      height: 17px;
    }

    &:hover,
    &:focus {
      @extend %filter-dropdown-item-btn-hover;
    }
  }

  .dropdown-light-content {
    font-size: 14px;
    font-weight: 400;
  }

  .dropdown-user {
    display: -webkit-flex;
    display: flex;
  }

  .dropdown-user-details {
    display: -webkit-flex;
    display: flex;
    -webkit-flex-direction: column;
    flex-direction: column;

    &> span {
      white-space: normal;
      word-break: break-all;
    }
  }
}

.filter-dropdown-item.droplab-item-active .btn {
  @extend %filter-dropdown-item-btn-hover;
}

.filter-dropdown-loading {
  padding: 8px 16px;
}
